<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>tools/triggers.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tools/triggers.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2004-2006 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_TRIGGERS__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_TRIGGERS__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;behaviourlayer/behave.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;tools/parameters.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;tools/sequences.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">// Triggers</span>
<a name="l00029"></a>00029 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="code" href="structiTrigger.html" title="This is a trigger.">iTrigger</a>;
<a name="l00032"></a>00032 
<a name="l00037"></a><a class="code" href="structiTriggerCallback.html">00037</a> <span class="keyword">struct </span><a class="code" href="structiTriggerCallback.html" title="A trigger will get pointers to call back the quest when the trigger fires through this interface...">iTriggerCallback</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   SCF_INTERFACE (<a class="code" href="structiTriggerCallback.html" title="A trigger will get pointers to call back the quest when the trigger fires through this interface...">iTriggerCallback</a>, 0, 0, 1);
<a name="l00040"></a>00040 
<a name="l00042"></a>00042   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTriggerCallback.html#a6193c3e3c988dd0159ab4353fec61f08" title="Trigger fired.">TriggerFired</a> (<a class="code" href="structiTrigger.html" title="This is a trigger.">iTrigger</a>* trigger, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00043"></a>00043 };
<a name="l00044"></a>00044 
<a name="l00052"></a><a class="code" href="structiTrigger.html">00052</a> <span class="keyword">struct </span><a class="code" href="structiTrigger.html" title="This is a trigger.">iTrigger</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   SCF_INTERFACE (<a class="code" href="structiTrigger.html" title="This is a trigger.">iTrigger</a>, 0, 0, 1);
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTrigger.html#aa92450fec431d0fee6c8a4c56c0b8b3c" title="Register a callback with this trigger.">RegisterCallback</a> (<a class="code" href="structiTriggerCallback.html" title="A trigger will get pointers to call back the quest when the trigger fires through this interface...">iTriggerCallback</a>* callback) = 0;
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTrigger.html#a30a56248e8ce090fe645df2f70a4ade7" title="Clear the callback.">ClearCallback</a> () = 0;
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTrigger.html#a71d1b2a2fd942bf5b58feb02fc0b2a36" title="Activate the trigger.">ActivateTrigger</a> () = 0;
<a name="l00071"></a>00071 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTrigger.html#a5a88d8b2232ab579fd242dbb3e06d56f" title="Deactivate the trigger.">DeactivateTrigger</a> () = 0;
<a name="l00076"></a>00076 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiTrigger.html#ab61b49963435848e36bbf7ce9ac052b1" title="Check the trigger immediatelly and return true if it is valid.">Check</a> () = 0;
<a name="l00085"></a>00085 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiTrigger.html#a1d9c2a120a2aaf3231db03363d317ebe" title="Activate the trigger and load state from databuf (persistence).">LoadAndActivateTrigger</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTrigger.html#a3644b5f2e1342aa3b7046d78a031d8ab" title="Save trigger state.">SaveTriggerState</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00097"></a>00097 };
<a name="l00098"></a>00098 
<a name="l00103"></a><a class="code" href="structiTriggerFactory.html">00103</a> <span class="keyword">struct </span><a class="code" href="structiTriggerFactory.html" title="A factory to create triggers.">iTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105   SCF_INTERFACE (<a class="code" href="structiTriggerFactory.html" title="A factory to create triggers.">iTriggerFactory</a>, 0, 0, 1);
<a name="l00106"></a>00106 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iTrigger&gt;</a> <a class="code" href="structiTriggerFactory.html#aa2238a069b18b012cbb97985dada10a9" title="Create a trigger.">CreateTrigger</a> (
<a name="l00113"></a>00113         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>&amp; params) = 0;
<a name="l00114"></a>00114 
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiTriggerFactory.html#aefb88a6d48cf8835bf4fdf7d1bb4cee6" title="Load this factory from a document node.">Load</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiDocumentNode.html">iDocumentNode</a>* node) = 0;
<a name="l00121"></a>00121 };
<a name="l00122"></a>00122 
<a name="l00131"></a><a class="code" href="structiTriggerType.html">00131</a> <span class="keyword">struct </span><a class="code" href="structiTriggerType.html" title="The trigger type is responsible for the creation of trigger factories.">iTriggerType</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133   SCF_INTERFACE (<a class="code" href="structiTriggerType.html" title="The trigger type is responsible for the creation of trigger factories.">iTriggerType</a>, 0, 0, 1);
<a name="l00134"></a>00134 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiTriggerType.html#ab8cc49a70fcc0f641d50ef4c0dda3b5a" title="Return the name for this trigger type.">GetName</a> () <span class="keyword">const</span> = 0;
<a name="l00139"></a>00139   
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iTriggerFactory&gt;</a> <a class="code" href="structiTriggerType.html#a0f143662bc6c7a00ba424fcc34904c20" title="Create a trigger factory.">CreateTriggerFactory</a> () = 0;
<a name="l00144"></a>00144 };
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00147"></a>00147 <span class="comment">// Specific trigger implementations.</span>
<a name="l00148"></a>00148 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00169"></a><a class="code" href="structiEnterSectorTriggerFactory.html">00169</a> <span class="comment"></span><span class="keyword">struct </span><a class="code" href="structiEnterSectorTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain sector is entered.">iEnterSectorTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171   SCF_INTERFACE (<a class="code" href="structiEnterSectorTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain sector is entered.">iEnterSectorTriggerFactory</a>, 0, 0, 1);
<a name="l00172"></a>00172 
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiEnterSectorTriggerFactory.html#a8e0d6706f34ffdbe34663591e969e2ec" title="Set the name of the entity containing the pccamera or pcmesh property class on which this trigger wil...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00182"></a>00182 
<a name="l00189"></a>00189   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiEnterSectorTriggerFactory.html#a76710c09d332341dc743c9e228de9726" title="Set the name of the sector on which this trigger will fire as soon as the camera enters that sector...">SetSectorParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* sector) = 0;
<a name="l00190"></a>00190 };
<a name="l00191"></a>00191 
<a name="l00213"></a><a class="code" href="structiInventoryTriggerFactory.html">00213</a> <span class="keyword">struct </span><a class="code" href="structiInventoryTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain inventory gets some entity...">iInventoryTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00214"></a>00214 {
<a name="l00215"></a>00215   SCF_INTERFACE (<a class="code" href="structiInventoryTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain inventory gets some entity...">iInventoryTriggerFactory</a>, 0, 0, 1);
<a name="l00216"></a>00216 
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiInventoryTriggerFactory.html#a6abe7217ad1d70a4515342a9f864b84d" title="Set the name of the entity containing the pcinventory property class on which this trigger will fire...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00226"></a>00226 
<a name="l00234"></a>00234   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiInventoryTriggerFactory.html#accd27fdc56df668ac3394b48b5b4d35c" title="Set the name of the entity to watch for.">SetChildEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* child_entity) = 0;
<a name="l00235"></a>00235 };
<a name="l00236"></a>00236 
<a name="l00255"></a><a class="code" href="structiMeshSelectTriggerFactory.html">00255</a> <span class="keyword">struct </span><a class="code" href="structiMeshSelectTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain mesh is selected.">iMeshSelectTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00256"></a>00256 {
<a name="l00257"></a>00257   SCF_INTERFACE (<a class="code" href="structiMeshSelectTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain mesh is selected.">iMeshSelectTriggerFactory</a>, 0, 0, 1);
<a name="l00258"></a>00258 
<a name="l00267"></a>00267   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMeshSelectTriggerFactory.html#ab2513404397201b0c85294e302a533ea" title="Set the name of the entity containing the pcmeshselect property class on which this trigger will fire...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00268"></a>00268 };
<a name="l00269"></a>00269 
<a name="l00284"></a><a class="code" href="structiMessageTriggerFactory.html">00284</a> <span class="keyword">struct </span><a class="code" href="structiMessageTriggerFactory.html" title="This interface is implemented by the trigger that fires when a message is sent.">iMessageTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00285"></a>00285 {
<a name="l00286"></a>00286   SCF_INTERFACE (<a class="code" href="structiMessageTriggerFactory.html" title="This interface is implemented by the trigger that fires when a message is sent.">iMessageTriggerFactory</a>, 0, 0, 1);
<a name="l00287"></a>00287 
<a name="l00293"></a>00293   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMessageTriggerFactory.html#ae767a9e9e2d4edaf1b98390c54312523" title="Set the name of the entity from which we want to listen to messages.">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity) = 0;
<a name="l00294"></a>00294 
<a name="l00301"></a>00301   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiMessageTriggerFactory.html#a56abec8d1394fcaef881c89f0ab3da60" title="Set the name of the message mask that we want to receive messages for.">SetMaskParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* mask) = 0;
<a name="l00302"></a>00302 };
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00328"></a><a class="code" href="structiOperationTriggerFactory.html">00328</a> <span class="keyword">struct </span><a class="code" href="structiOperationTriggerFactory.html" title="This interface is implemented by the operation trigger, that allows to combine several triggers using...">iOperationTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00329"></a>00329 {
<a name="l00330"></a>00330   SCF_INTERFACE (<a class="code" href="structiOperationTriggerFactory.html" title="This interface is implemented by the operation trigger, that allows to combine several triggers using...">iOperationTriggerFactory</a>, 0, 0, 1);
<a name="l00331"></a>00331 
<a name="l00338"></a>00338   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiOperationTriggerFactory.html#aae325beb9e7a2b9dfffe102178aaef8a" title="Set the operation this trigger will use to combine child triggers.">SetOperationParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* operation) = 0;
<a name="l00343"></a>00343   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray&lt;iTriggerFactory&gt;</a> &amp;<a class="code" href="structiOperationTriggerFactory.html#a3f2fb3719779b5f3fee1c22162bfef4a" title="Return the trigger factory list so that user can add new ones, remove them or clear the list...">GetTriggerFactories</a> () = 0;
<a name="l00344"></a>00344 };
<a name="l00345"></a>00345 
<a name="l00383"></a><a class="code" href="structiPropertyChangeTriggerFactory.html">00383</a> <span class="keyword">struct </span><a class="code" href="structiPropertyChangeTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain property passes a test on some...">iPropertyChangeTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00384"></a>00384 {
<a name="l00385"></a>00385   SCF_INTERFACE (<a class="code" href="structiPropertyChangeTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain property passes a test on some...">iPropertyChangeTriggerFactory</a>, 0, 0, 1);
<a name="l00386"></a>00386 
<a name="l00395"></a>00395   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertyChangeTriggerFactory.html#a7ec6e71378e49b985e60acb694423279" title="Set the name of the entity containing the pcproperties property class on which this trigger will fire...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00396"></a>00396 
<a name="l00402"></a>00402   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertyChangeTriggerFactory.html#a47ffd7ac95a2f07e0478b5a05d037296" title="Set the name of the property on which this trigger will fire.">SetPropertyParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* prop) = 0;
<a name="l00403"></a>00403 
<a name="l00410"></a>00410   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertyChangeTriggerFactory.html#aabd48e3de6fde37e2d99591cfefca3aa" title="Set the value of the property on which this trigger will fire.">SetValueParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* value) = 0;
<a name="l00411"></a>00411 
<a name="l00417"></a>00417   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertyChangeTriggerFactory.html#af2ab28a5ff90138bdf815af8c844b9f1" title="Set the operation this trigger will test with.">SetOperationParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* op) = 0;
<a name="l00418"></a>00418 
<a name="l00425"></a>00425   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPropertyChangeTriggerFactory.html#a8ff0ab64afa2a0a270262719d12c81da" title="Set whether the trigger will fire only on an actual change (so the condition has to become true)...">SetOnChangeOnly</a> (<span class="keywordtype">bool</span> on_change) = 0;
<a name="l00426"></a>00426 };
<a name="l00427"></a>00427 
<a name="l00445"></a><a class="code" href="structiSequenceFinishTriggerFactory.html">00445</a> <span class="keyword">struct </span><a class="code" href="structiSequenceFinishTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain sequence finishes.">iSequenceFinishTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00446"></a>00446 {
<a name="l00447"></a>00447   SCF_INTERFACE (<a class="code" href="structiSequenceFinishTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain sequence finishes.">iSequenceFinishTriggerFactory</a>, 0, 0, 1);
<a name="l00448"></a>00448 
<a name="l00457"></a>00457   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiSequenceFinishTriggerFactory.html#a8a1eea3bf5be074522e336eb54699576" title="Set the name of the entity containing the pcquest property class on which this trigger will fire...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00458"></a>00458 
<a name="l00466"></a>00466   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiSequenceFinishTriggerFactory.html#a637dee006c3b7933c3a27523aa4a5264" title="Set the name of the sequence.">SetSequenceParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* sequence) = 0;
<a name="l00467"></a>00467 
<a name="l00473"></a>00473   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiSequenceFinishTriggerFactory.html#a3657dbcfbdcb5bdc7ecb6d7f3a3698e1" title="Set the sequence to observe.">SetSequence</a> (<a class="code" href="structiCelSequence.html" title="A sequence.">iCelSequence</a>* sequence) = 0;
<a name="l00474"></a>00474 };
<a name="l00475"></a>00475 
<a name="l00488"></a><a class="code" href="structiTimeoutTriggerFactory.html">00488</a> <span class="keyword">struct </span><a class="code" href="structiTimeoutTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain time has expired.">iTimeoutTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00489"></a>00489 {
<a name="l00490"></a>00490   SCF_INTERFACE (<a class="code" href="structiTimeoutTriggerFactory.html" title="This interface is implemented by the trigger that fires when a certain time has expired.">iTimeoutTriggerFactory</a>, 0, 0, 1);
<a name="l00491"></a>00491 
<a name="l00497"></a>00497   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTimeoutTriggerFactory.html#a0951dbd3c03f6629f2a021beda5a6b27" title="Set the timeout on which this trigger will fire.">SetTimeoutParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* timeout_par) = 0;
<a name="l00498"></a>00498 };
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00521"></a><a class="code" href="structiTriggerTriggerFactory.html">00521</a> <span class="keyword">struct </span><a class="code" href="structiTriggerTriggerFactory.html" title="This interface is implemented by the trigger that fires when a pctrigger fires.">iTriggerTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00522"></a>00522 {
<a name="l00523"></a>00523   SCF_INTERFACE (<a class="code" href="structiTriggerTriggerFactory.html" title="This interface is implemented by the trigger that fires when a pctrigger fires.">iTriggerTriggerFactory</a>, 0, 0, 1);
<a name="l00524"></a>00524 
<a name="l00533"></a>00533   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTriggerTriggerFactory.html#a0514d678c1bbcf83824f5198400dcb56" title="Set the name of the entity containing the pccamera or pcmesh property class on which this trigger wil...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00534"></a>00534 
<a name="l00539"></a>00539   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTriggerTriggerFactory.html#a7333b77094ab9247f21ca6ec613dea82" title="If this function is called then the trigger will fire on &#39;leaves&#39; instead of &#39;enters&#39;.">EnableLeave</a> () = 0;
<a name="l00540"></a>00540 };
<a name="l00541"></a>00541 
<a name="l00567"></a><a class="code" href="structiWatchTriggerFactory.html">00567</a> <span class="keyword">struct </span><a class="code" href="structiWatchTriggerFactory.html" title="This interface is implemented by the trigger that fires when a mesh becomes visible.">iWatchTriggerFactory</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00568"></a>00568 {
<a name="l00569"></a>00569   SCF_INTERFACE (<a class="code" href="structiWatchTriggerFactory.html" title="This interface is implemented by the trigger that fires when a mesh becomes visible.">iWatchTriggerFactory</a>, 0, 0, 1);
<a name="l00570"></a>00570 
<a name="l00579"></a>00579   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiWatchTriggerFactory.html#a59152ef7cdfe840a96fd6066b3c41446" title="Set the name of the source entity containing the pcmesh property class on which this trigger will fir...">SetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity, <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00580"></a>00580 
<a name="l00589"></a>00589   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiWatchTriggerFactory.html#ae804773f3ae5142175f9a44fea3d005c" title="Set the name of the target entity containing the pcmesh property class on which this trigger will fir...">SetTargetEntityParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entity,
<a name="l00590"></a>00590       <span class="keyword">const</span> <span class="keywordtype">char</span>* tag = 0) = 0;
<a name="l00591"></a>00591 
<a name="l00599"></a>00599   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiWatchTriggerFactory.html#a212121f358fe2e5a0fb742bca2bd0302" title="Set the interval (in milliseconds) after which this trigger will check visibility again...">SetChecktimeParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* time) = 0;
<a name="l00600"></a>00600 
<a name="l00607"></a>00607   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiWatchTriggerFactory.html#a35b8109317af5309fbce80851aa273fb" title="Set the maximum radius for visibility checking.">SetRadiusParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* radius) = 0;
<a name="l00608"></a>00608 
<a name="l00616"></a>00616   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiWatchTriggerFactory.html#a4aed6450b17b149b86c3cd55f9c87bbd" title="Optional offset parameter.">SetOffsetParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* offsetx,
<a name="l00617"></a>00617       <span class="keyword">const</span> <span class="keywordtype">char</span>* offsety, <span class="keyword">const</span> <span class="keywordtype">char</span>* offsetz) = 0;
<a name="l00618"></a>00618 };
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00621"></a>00621 
<a name="l00625"></a>00625 <span class="preprocessor">#define CEL_DECLARE_TRIGGERTYPE(name,id)                                \</span>
<a name="l00626"></a>00626 <span class="preprocessor">class cel##name##TriggerType : public scfImplementation2&lt;               \</span>
<a name="l00627"></a>00627 <span class="preprocessor">                cel##name##TriggerType,iTriggerType,iComponent&gt;         \</span>
<a name="l00628"></a>00628 <span class="preprocessor">{                                                                       \</span>
<a name="l00629"></a>00629 <span class="preprocessor">public:                                                                 \</span>
<a name="l00630"></a>00630 <span class="preprocessor">  iObjectRegistry* object_reg;                                          \</span>
<a name="l00631"></a>00631 <span class="preprocessor">  csWeakRef&lt;iCelPlLayer&gt; pl;                                            \</span>
<a name="l00632"></a>00632 <span class="preprocessor">  cel##name##TriggerType (iBase* parent);                       \</span>
<a name="l00633"></a>00633 <span class="preprocessor">  virtual ~cel##name##TriggerType () { }                                \</span>
<a name="l00634"></a>00634 <span class="preprocessor">  virtual bool Initialize (iObjectRegistry*);                   \</span>
<a name="l00635"></a>00635 <span class="preprocessor">  virtual const char* GetName () const { return id; }                   \</span>
<a name="l00636"></a>00636 <span class="preprocessor">  virtual csPtr&lt;iTriggerFactory&gt; CreateTriggerFactory ();               \</span>
<a name="l00637"></a>00637 <span class="preprocessor">};</span>
<a name="l00638"></a>00638 <span class="preprocessor"></span>
<a name="l00642"></a>00642 <span class="preprocessor">#define CEL_IMPLEMENT_TRIGGERTYPE(name)                                 \</span>
<a name="l00643"></a>00643 <span class="preprocessor">cel##name##TriggerType::cel##name##TriggerType (                                \</span>
<a name="l00644"></a>00644 <span class="preprocessor">        iBase* parent) : scfImplementationType (this, parent),  \</span>
<a name="l00645"></a>00645 <span class="preprocessor">        object_reg(0)                                                                                   \</span>
<a name="l00646"></a>00646 <span class="preprocessor">{                                                                                                                       \</span>
<a name="l00647"></a>00647 <span class="preprocessor">}                                                                                                                       \</span>
<a name="l00648"></a>00648 <span class="preprocessor">bool cel##name##TriggerType::Initialize (                                       \</span>
<a name="l00649"></a>00649 <span class="preprocessor">        iObjectRegistry* object_reg)                                                    \</span>
<a name="l00650"></a>00650 <span class="preprocessor">{                                                                       \</span>
<a name="l00651"></a>00651 <span class="preprocessor">  cel##name##TriggerType::object_reg = object_reg;                      \</span>
<a name="l00652"></a>00652 <span class="preprocessor">  pl = csQueryRegistry&lt;iCelPlLayer&gt; (object_reg);                       \</span>
<a name="l00653"></a>00653 <span class="preprocessor">  return true;                                                                                          \</span>
<a name="l00654"></a>00654 <span class="preprocessor">}                                                                       \</span>
<a name="l00655"></a>00655 <span class="preprocessor">csPtr&lt;iTriggerFactory&gt; cel##name##TriggerType::CreateTriggerFactory () \</span>
<a name="l00656"></a>00656 <span class="preprocessor">{                                                                       \</span>
<a name="l00657"></a>00657 <span class="preprocessor">  cel##name##TriggerFactory* fact = new cel##name##TriggerFactory (this); \</span>
<a name="l00658"></a>00658 <span class="preprocessor">  return fact;                                                          \</span>
<a name="l00659"></a>00659 <span class="preprocessor">}</span>
<a name="l00660"></a>00660 <span class="preprocessor"></span>
<a name="l00661"></a>00661 <span class="preprocessor">#endif // __CEL_TRIGGERS__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
